// Nano1xx WDT Wake up Demo code
// Copyright  Nuvoton(SH) Technology Corp. All rights reserved.  2013/5/2

#include "nano1xx.h"

//// WDTʼ //////////////////////////////////////////////////////////////////////////
void WDT_Init(void)
{
  UNLOCKREG();	
    CLK->APBCLK |= CLK_APBCLK_WDT_EN ;                     // ʹWDTʱ,ʱԴ10KHz
	WDT->CTL =	WDT_CTL_WTE | WDT_CTL_WTR | WDT_CTL_WTIS_2POW16 | WDT_CTL_WTWKE ;							
  LOCKREG();	 
  WDT->ISR |= WDT_ISR_WDTIS | WDT_ISR_WDTWAKEIS ;          // WDTжϱ־ͻѱ־
  WDT->IER |= WDT_IER_WDTIE;                               // ʹWDTж
  NVIC_SetPriority(WDT_IRQn, 3) ;                          // ȼ
  NVIC_EnableIRQ(WDT_IRQn) ;                    //ʹжWDTܽCPU
}

int32_t main(void)							   
{  	
  uint32_t Cnt ;
  	
  UNLOCKREG();
    CLK->PWRCTL = CLK_PWRCTL_HIRC_EN 
                | CLK_PWRCTL_LIRC_EN 
                | CLK_PWRCTL_PWRDOWN_EN 
                | CLK_PWRCTL_DELY_EN ;	   
    while((CLK->CLKSTATUS & CLK_CLKSTATUS_HIRC_STB) == 0); 
  LOCKREG();
  SCB->SCR  |= 0x04 ;	                                   //Inform core ready to deep-sleep
 	
  WDT_Init();

  GCR->PA_L_MFP = 0 ;                                      //õPINóʹ
  GCR->PA_H_MFP = 0 ;
  GCR->PB_L_MFP = 0 ;
  GCR->PB_H_MFP = 0 ;
  GCR->PC_L_MFP = 0 ;
  GCR->PC_H_MFP = 0 ;
  GCR->PD_L_MFP = 0 ;
  GCR->PD_H_MFP = 0 ;
  GCR->PE_L_MFP = 0 ;
  GCR->PE_H_MFP = 0 ;
  GCR->PF_L_MFP = 0x00007700 ;

  GPIOA->PMD = 0 ;                                         // ó
  GPIOB->PMD = 0 ;
  GPIOC->PMD = 0 ;
  GPIOD->PMD = 0 ;
  GPIOE->PMD = 0 ;
  GPIOF->PMD = 0 ;

  GPIOA->PUEN = 0xFFFF ;                                   // ʹ
  GPIOB->PUEN = 0xFFFF ;
  GPIOC->PUEN = 0xFFFF ;
  GPIOD->PUEN = 0xFFFF ;
  GPIOE->PUEN = 0xFFFF ;
  GPIOF->PUEN = 0x0033 ;               

  GPIOE->PMD   =  (GPIOE->PMD & ~GPIO_PMD_PMD6_MASK | GPIO_PMD_PMD6_OUTPUT) ;
  GPIOE->DOUT &= ~0x40;                                    // LED
  	
  while (1){

    GPIOE->DOUT^=0x40;                                     // LED˸
    for(Cnt=0;Cnt<300;++Cnt);                              //Ҫ֤һWDTʱ

	UNLOCKREG();                                   
      CLK->PWRCTL |= CLK_PWRCTL_PWRDOWN_EN;	               // ÿζҪ1
    LOCKREG();                                             
    __wfi() ;                                              // ״̬                            
  }                       //ÿλѺ, һWDTʱ(Լ100us),ſٴν״̬
}                //жʱ,ʱ¶ʱֵ, ٴνʱǷ100us

//// WDTжϴ ////////////////////////////////////////////////////////////////////////
void WDT_IRQHandler(void) 
{ 
  WDT->ISR |= WDT_ISR_WDTIS ;                              // WDTжϱ־
}

void SystemInit(void)
{
}
